#ifndef NAT_H
#define NAT_H

#include <memory>

class Nat {
 public:
  // Returns x plus y where x is this.
  virtual std::shared_ptr<Nat> plus(std::shared_ptr<Nat> y) const = 0;
  // Returns f(x) where x is this.
  virtual std::shared_ptr<Nat> fibonacci() const = 0;
  // Returns f(x+1) where x is this.
  virtual std::shared_ptr<Nat> fibonacciSuccessor() const = 0;
  // returns an integer representation.
  virtual int toInt() const = 0;
};

#endif // NAT_H
