#include "successor.h"

// constructor
Successor::Successor(std::shared_ptr<Nat> x) : x(x) {}

std::shared_ptr<Nat> Successor::plus(std::shared_ptr<Nat> y) const {
  std::shared_ptr<Nat> answer(new Successor(x->plus(y)));
  return answer;
}

std::shared_ptr<Nat> Successor::fibonacci() const {
  return x->fibonacciSuccessor();
}

std::shared_ptr<Nat> Successor::fibonacciSuccessor() const {
  std::shared_ptr<Nat> successor_of_x(new Successor(x));
  return x->fibonacci()->plus(successor_of_x->fibonacci());
}

int Successor::toInt() const {
  return x->toInt() + 1;
}
